/* The following code was generated by JFlex 1.3.5*/

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (C) 1998-2001  Gerwin Klein <lsf@jflex.de>                    *
 * All rights reserved.                                                    *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify    *
 * it under the terms of the GNU General Public License. See the file      *
 * COPYRIGHT for more information.                                         *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                 *
 *                                                                         *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/* Java 1.2 language lexer specification */

/* Use together with unicode.flex for Unicode preprocesssing */
/* and java12.cup for a Java 1.2 parser                      */

/* Note that this lexer specification is not tuned for speed.
   It is in fact quite slow on integer and floating point literals, 
   because the input is read twice and the methods used to parse
   the numbers are not very fast. 
   For a production quality application (e.g. a Java compiler) 
   this could be optimized */

package polyglot.ext.jedd.parse;

import java_cup.runtime.Symbol;
import polyglot.lex.Lexer;
import polyglot.lex.*;
import polyglot.util.Position;
import polyglot.util.ErrorQueue;
import polyglot.util.ErrorInfo;


/**
 * */
public class Lexer_c implements Lexer {

  /** This character denotes the end of file */
  final public static int YYEOF = -1;

  /** initial size of the lookahead buffer */
  final private static int YY_BUFFERSIZE = 16384;

  /** lexical states */
  final public static int STRING = 1;
  final public static int YYINITIAL = 0;
  final public static int CHARLITERAL = 2;

  /** 
   * Translates characters to character classes
   */
  final private static String yycmap_packed = 
    "\11\7\1\3\1\2\1\0\1\3\1\1\16\7\4\0\1\3\1\72"+
    "\1\24\1\0\1\6\1\102\1\76\1\25\1\57\1\60\1\5\1\100"+
    "\1\66\1\23\1\21\1\4\1\10\1\16\2\15\4\17\2\11\1\75"+
    "\1\65\1\71\1\67\1\70\1\74\1\0\1\14\1\103\1\14\1\104"+
    "\1\22\1\20\5\6\1\12\13\6\1\13\2\6\1\63\1\26\1\64"+
    "\1\101\1\6\1\0\1\27\1\30\1\34\1\46\1\37\1\50\1\53"+
    "\1\43\1\44\1\6\1\41\1\36\1\51\1\40\1\35\1\52\1\6"+
    "\1\33\1\31\1\32\1\45\1\54\1\55\1\47\1\42\1\56\1\61"+
    "\1\77\1\62\1\73\41\7\2\0\4\6\4\0\1\6\12\0\1\6"+
    "\4\0\1\6\5\0\27\6\1\0\37\6\1\0\u0128\6\2\0\22\6"+
    "\34\0\136\6\2\0\11\6\2\0\7\6\16\0\2\6\16\0\5\6"+
    "\11\0\1\6\21\0\117\7\21\0\3\7\27\0\1\6\13\0\1\6"+
    "\1\0\3\6\1\0\1\6\1\0\24\6\1\0\54\6\1\0\10\6"+
    "\2\0\32\6\14\0\202\6\1\0\4\7\5\0\71\6\2\0\2\6"+
    "\2\0\2\6\3\0\46\6\2\0\2\6\67\0\46\6\2\0\1\6"+
    "\7\0\47\6\11\0\21\7\1\0\27\7\1\0\3\7\1\0\1\7"+
    "\1\0\2\7\1\0\1\7\13\0\33\6\5\0\3\6\56\0\32\6"+
    "\5\0\13\6\13\7\12\0\12\7\6\0\1\7\143\6\1\0\1\6"+
    "\7\7\2\0\6\7\2\6\2\7\1\0\4\7\2\0\12\7\3\6"+
    "\22\0\1\7\1\6\1\7\33\6\3\0\33\7\65\0\46\6\13\7"+
    "\u0150\0\3\7\1\0\65\6\2\0\1\7\1\6\20\7\2\0\1\6"+
    "\4\7\3\0\12\6\2\7\2\0\12\7\21\0\3\7\1\0\10\6"+
    "\2\0\2\6\2\0\26\6\1\0\7\6\1\0\1\6\3\0\4\6"+
    "\2\0\1\7\1\0\7\7\2\0\2\7\2\0\3\7\11\0\1\7"+
    "\4\0\2\6\1\0\3\6\2\7\2\0\12\7\4\6\16\0\1\7"+
    "\2\0\6\6\4\0\2\6\2\0\26\6\1\0\7\6\1\0\2\6"+
    "\1\0\2\6\1\0\2\6\2\0\1\7\1\0\5\7\4\0\2\7"+
    "\2\0\3\7\13\0\4\6\1\0\1\6\7\0\14\7\3\6\14\0"+
    "\3\7\1\0\7\6\1\0\1\6\1\0\3\6\1\0\26\6\1\0"+
    "\7\6\1\0\2\6\1\0\5\6\2\0\1\7\1\6\10\7\1\0"+
    "\3\7\1\0\3\7\2\0\1\6\17\0\1\6\5\0\12\7\21\0"+
    "\3\7\1\0\10\6\2\0\2\6\2\0\26\6\1\0\7\6\1\0"+
    "\2\6\2\0\4\6\2\0\1\7\1\6\6\7\3\0\2\7\2\0"+
    "\3\7\10\0\2\7\4\0\2\6\1\0\3\6\4\0\12\7\22\0"+
    "\2\7\1\0\6\6\3\0\3\6\1\0\4\6\3\0\2\6\1\0"+
    "\1\6\1\0\2\6\3\0\2\6\3\0\3\6\3\0\10\6\1\0"+
    "\3\6\4\0\5\7\3\0\3\7\1\0\4\7\11\0\1\7\17\0"+
    "\11\7\21\0\3\7\1\0\10\6\1\0\3\6\1\0\27\6\1\0"+
    "\12\6\1\0\5\6\4\0\7\7\1\0\3\7\1\0\4\7\7\0"+
    "\2\7\11\0\2\6\4\0\12\7\22\0\2\7\1\0\10\6\1\0"+
    "\3\6\1\0\27\6\1\0\12\6\1\0\5\6\4\0\7\7\1\0"+
    "\3\7\1\0\4\7\7\0\2\7\7\0\1\6\1\0\2\6\4\0"+
    "\12\7\22\0\2\7\1\0\10\6\1\0\3\6\1\0\27\6\1\0"+
    "\20\6\4\0\6\7\2\0\3\7\1\0\4\7\11\0\1\7\10\0"+
    "\2\6\4\0\12\7\22\0\2\7\1\0\22\6\3\0\30\6\1\0"+
    "\11\6\1\0\1\6\2\0\7\6\3\0\1\7\4\0\6\7\1\0"+
    "\1\7\1\0\10\7\22\0\2\7\15\0\60\6\1\7\2\6\7\7"+
    "\4\0\10\6\10\7\1\0\12\7\47\0\2\6\1\0\1\6\2\0"+
    "\2\6\1\0\1\6\2\0\1\6\6\0\4\6\1\0\7\6\1\0"+
    "\3\6\1\0\1\6\1\0\1\6\2\0\2\6\1\0\4\6\1\7"+
    "\2\6\6\7\1\0\2\7\1\6\2\0\5\6\1\0\1\6\1\0"+
    "\6\7\2\0\12\7\2\0\2\6\42\0\1\6\27\0\2\7\6\0"+
    "\12\7\13\0\1\7\1\0\1\7\1\0\1\7\4\0\2\7\10\6"+
    "\1\0\42\6\6\0\24\7\1\0\2\7\4\6\4\0\10\7\1\0"+
    "\44\7\11\0\1\7\71\0\42\6\1\0\5\6\1\0\2\6\1\0"+
    "\7\7\3\0\4\7\6\0\12\7\6\0\6\6\4\7\106\0\46\6"+
    "\12\0\47\6\11\0\132\6\5\0\104\6\5\0\122\6\6\0\7\6"+
    "\1\0\77\6\1\0\1\6\1\0\4\6\2\0\7\6\1\0\1\6"+
    "\1\0\4\6\2\0\47\6\1\0\1\6\1\0\4\6\2\0\37\6"+
    "\1\0\1\6\1\0\4\6\2\0\7\6\1\0\1\6\1\0\4\6"+
    "\2\0\7\6\1\0\7\6\1\0\27\6\1\0\37\6\1\0\1\6"+
    "\1\0\4\6\2\0\7\6\1\0\47\6\1\0\23\6\16\0\11\7"+
    "\56\0\125\6\14\0\u026c\6\2\0\10\6\12\0\32\6\5\0\113\6"+
    "\225\0\64\6\40\7\7\0\1\6\4\0\12\7\41\0\4\7\1\0"+
    "\12\7\6\0\130\6\10\0\51\6\1\7\u0556\0\234\6\4\0\132\6"+
    "\6\0\26\6\2\0\6\6\2\0\46\6\2\0\6\6\2\0\10\6"+
    "\1\0\1\6\1\0\1\6\1\0\1\6\1\0\37\6\2\0\65\6"+
    "\1\0\7\6\1\0\1\6\3\0\3\6\1\0\7\6\3\0\4\6"+
    "\2\0\6\6\4\0\15\6\5\0\3\6\1\0\7\6\17\0\4\7"+
    "\32\0\5\7\20\0\2\6\51\0\6\7\17\0\1\6\40\0\20\6"+
    "\40\0\15\7\4\0\1\7\40\0\1\6\4\0\1\6\2\0\12\6"+
    "\1\0\1\6\3\0\5\6\6\0\1\6\1\0\1\6\1\0\1\6"+
    "\1\0\4\6\1\0\3\6\1\0\7\6\46\0\44\6\u0e81\0\3\6"+
    "\31\0\11\6\6\7\1\0\5\6\2\0\3\6\6\0\124\6\4\0"+
    "\2\7\2\0\2\6\2\0\136\6\6\0\50\6\4\0\136\6\21\0"+
    "\30\6\u0248\0\u19b6\6\112\0\u51a6\6\132\0\u048d\6\u0773\0\u2ba4\6\u215c\0"+
    "\u012e\6\322\0\7\6\14\0\5\6\5\0\1\6\1\7\12\6\1\0"+
    "\15\6\1\0\5\6\1\0\1\6\1\0\2\6\1\0\2\6\1\0"+
    "\154\6\41\0\u016b\6\22\0\100\6\2\0\66\6\50\0\14\6\44\0"+
    "\4\7\17\0\2\6\30\0\3\6\31\0\1\6\6\0\3\6\1\0"+
    "\1\6\1\0\207\6\2\0\1\7\4\0\1\6\13\0\12\7\7\0"+
    "\32\6\4\0\1\6\1\0\32\6\12\0\132\6\3\0\6\6\2\0"+
    "\6\6\2\0\6\6\2\0\3\6\3\0\2\6\3\0\2\6\22\0"+
    "\3\7\4\0";

  /** 
   * Translates characters to character classes
   */
  final private static char [] yycmap = yy_unpack_cmap(yycmap_packed);

  /** 
   * Translates a state to a row index in the transition table
   */
  final private static int yy_rowMap [] = { 
        0,    69,   138,   207,   276,   207,   345,   414,   483,   552, 
      621,   690,   759,   828,   207,   207,   897,   966,  1035,  1104, 
     1173,  1242,  1311,  1380,  1449,  1518,  1587,  1656,  1725,  1794, 
     1863,  1932,   207,   207,   207,   207,   207,   207,   207,   207, 
     2001,  2070,  2139,  2208,   207,   207,   207,  2277,  2346,  2415, 
     2484,  2553,  2622,  2691,   207,   207,  2760,  2829,  2898,   207, 
     2967,  3036,  3105,   207,   207,  3174,  3243,   207,  3312,  3381, 
     3450,  3519,   207,  3588,  3657,   207,   207,   207,   207,   207, 
     3726,  3795,  3864,  3933,  4002,  4071,  4140,  4209,  4278,  4347, 
     4416,  4485,  4554,  4623,  4692,  4761,  4830,  4899,  4968,  5037, 
     5106,  5175,  5244,  5313,   483,  5382,  5451,  5520,  5589,  5658, 
     5727,  5796,  5865,  5934,  6003,  6072,  6141,  6210,   207,   207, 
      207,  6279,   207,  6348,   207,   207,   207,   207,   207,   207, 
      207,   207,   207,   207,  6417,  6486,   207,   207,   207,   207, 
      207,   207,   207,   207,   207,  6555,  6624,  6693,  6762,  6831, 
     6900,  6969,  7038,  7107,  7176,  7245,   207,  7314,  7383,  7452, 
     7521,  7590,  7659,  7728,  7797,  7866,  7935,  8004,  8073,  8142, 
     8211,  8280,  8349,  8418,  8487,   483,  8556,  8625,  8694,  8763, 
     8832,  8901,  8970,  9039,  9108,  9177,  9246,  9315,  9384,   483, 
     9453,  9522,  9591,  9660,  9729,  9798,  9867,   483,  9936, 10005, 
    10074, 10143, 10212, 10281, 10350, 10419, 10488, 10557,   207, 10626, 
      207,   207,  6624,   207, 10695,   207,   207,   207,   207,   207, 
      207,   207,   207, 10764,   207, 10833, 10902, 10971, 11040, 11109, 
    11178, 11247,   483, 11316, 11385, 11454, 11523, 11592, 11661, 11730, 
      483, 11799,   483, 11868,   483, 11937, 12006, 12075, 12144,   483, 
      483,   483, 12213, 12282,   483, 12351, 12420, 12489, 12558, 12627, 
    12696, 12765, 12834, 12903, 12972, 13041, 13110, 13179,   483, 13248, 
      483, 13317,   207, 13386, 13455, 13524, 13593, 13662,   483, 13731, 
    13800, 13869, 13938,   483,   483, 14007, 14076, 14145, 14214,   483, 
      483, 14283,   483, 14352, 14421, 14490, 14559, 14628, 14697, 14766, 
    14835,   483,   483, 14904, 14973, 15042, 15111, 15180, 15249,   483, 
    15318, 15387, 15456, 15525,   483, 15594,   483, 15663, 15732,   483, 
    15801,   483,   483, 15870, 15939,   483, 16008, 16077,   483, 16146, 
      483, 16215, 16284, 16353, 16422, 16491,   483, 16560, 16629, 16698, 
    16767, 16836,   483, 16905, 16974, 17043, 17112,   483, 17181, 17250, 
    17319,   483,   483,   483, 17388,   483, 17457, 17526, 17595, 17664, 
      483,   483, 17733, 17802,   483, 17871, 17940, 18009, 18078,   483, 
    18147, 18216, 18285, 18354,   483, 18423,   483, 18492,   483, 18561, 
    18630, 18699, 18768,   483,   483, 18837, 18906, 18975, 19044, 19113, 
    19182, 19251,   483, 19320, 19389, 19458, 19527, 19596, 19665, 19734, 
    19803, 19872, 19941, 20010, 20079, 20148, 20217, 20217, 20286, 20355, 
    20424, 20493, 20562, 20631
  };

  /** 
   * The packed transition table of the DFA (part 0)
   */
  final private static String yy_packed0 = 
    "\1\4\1\5\2\6\1\7\1\10\1\11\1\4\1\12"+
    "\1\13\3\11\1\13\1\14\1\13\1\11\1\15\1\11"+
    "\1\16\1\17\1\20\1\4\1\21\1\22\1\23\1\24"+
    "\1\25\1\26\1\11\1\27\1\30\1\31\3\11\1\32"+
    "\1\11\1\33\1\11\1\34\1\11\1\35\1\36\1\37"+
    "\1\40\1\11\1\41\1\42\1\43\1\44\1\45\1\46"+
    "\1\47\1\50\1\51\1\52\1\53\1\54\1\55\1\56"+
    "\1\57\1\60\1\61\1\62\1\63\1\64\2\11\1\65"+
    "\1\66\1\67\21\65\1\70\1\65\1\71\56\65\1\72"+
    "\1\73\1\74\22\72\1\4\1\75\56\72\107\0\1\6"+
    "\106\0\1\76\1\77\61\0\1\100\104\0\1\101\23\0"+
    "\13\11\1\0\1\11\4\0\30\11\24\0\2\11\10\0"+
    "\1\102\1\103\1\104\1\105\1\0\1\106\1\107\1\110"+
    "\1\111\1\112\1\113\13\0\1\104\1\113\6\0\1\114"+
    "\1\105\1\111\32\0\1\115\1\114\10\0\2\13\1\104"+
    "\2\0\3\13\1\111\1\112\1\113\13\0\1\104\1\113"+
    "\6\0\1\114\1\0\1\111\33\0\1\114\10\0\2\13"+
    "\1\104\2\0\3\13\1\111\1\112\1\113\13\0\1\104"+
    "\1\113\6\0\1\114\1\0\1\111\32\0\1\116\1\114"+
    "\10\0\2\112\3\0\3\112\110\0\1\117\43\0\1\120"+
    "\23\0\13\11\1\0\1\11\4\0\1\11\1\121\1\122"+
    "\25\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\4\11\1\123\1\11\1\124\4\11\1\125\14\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\3\11\1\126"+
    "\7\11\1\127\1\130\1\11\1\131\7\11\1\132\1\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\4\11"+
    "\1\133\7\11\1\134\13\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\10\11\1\135\17\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\1\136\5\11\1\137"+
    "\1\140\4\11\1\141\13\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\6\11\1\142\21\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\7\11\1\143\10\11"+
    "\1\144\7\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\1\145\7\11\1\146\5\11\1\147\11\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\11\11\1\150"+
    "\7\11\1\151\1\152\5\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\6\11\1\153\1\11\1\154\17\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\1\155"+
    "\5\11\1\156\1\157\5\11\1\160\12\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\1\161\3\11\1\162"+
    "\11\11\1\163\11\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\6\11\1\164\21\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\6\11\1\165\21\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\14\11\1\166"+
    "\13\11\24\0\2\11\67\0\1\167\1\170\103\0\1\171"+
    "\1\172\103\0\1\173\1\0\1\174\102\0\1\175\104\0"+
    "\1\176\6\0\1\177\75\0\1\200\7\0\1\201\74\0"+
    "\1\202\10\0\1\203\73\0\1\204\104\0\1\205\15\0"+
    "\1\65\2\0\21\65\1\0\1\65\1\0\56\65\2\0"+
    "\1\67\102\0\2\206\1\0\5\206\1\207\4\206\2\207"+
    "\1\210\4\206\1\211\1\212\1\213\1\206\1\214\1\206"+
    "\1\215\1\216\4\206\1\217\7\206\1\220\34\206\25\0"+
    "\1\221\61\0\1\74\102\0\2\206\1\0\5\206\1\222"+
    "\4\206\2\222\1\223\4\206\1\224\1\225\1\226\1\206"+
    "\1\227\1\206\1\230\1\231\4\206\1\232\7\206\1\233"+
    "\34\206\1\76\1\5\1\6\102\76\105\234\10\0\1\102"+
    "\1\103\1\235\2\0\1\106\1\107\1\110\1\111\1\112"+
    "\1\113\13\0\1\235\1\113\6\0\1\114\1\0\1\111"+
    "\33\0\1\114\10\0\2\103\3\0\3\103\1\111\1\112"+
    "\1\113\14\0\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\1\236\1\237\2\0\5\237\1\0\1\237"+
    "\4\0\2\237\3\0\1\237\2\0\1\237\6\0\1\237"+
    "\1\0\1\237\32\0\2\237\10\0\1\240\1\103\1\235"+
    "\2\0\3\240\1\111\1\112\1\113\13\0\1\235\1\113"+
    "\6\0\1\114\1\0\1\111\33\0\1\114\10\0\1\110"+
    "\1\103\1\235\2\0\3\110\1\111\1\112\1\113\13\0"+
    "\1\235\1\113\6\0\1\114\1\0\1\111\33\0\1\114"+
    "\10\0\1\241\1\103\1\235\2\0\3\241\1\111\1\112"+
    "\1\113\13\0\1\235\1\113\6\0\1\114\1\0\1\111"+
    "\33\0\1\114\10\0\2\112\3\0\3\112\1\111\1\0"+
    "\1\113\14\0\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\2\242\3\0\3\242\3\0\1\243\54\0"+
    "\1\243\12\0\13\11\1\0\1\11\4\0\2\11\1\244"+
    "\25\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\2\11\1\245\25\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\10\11\1\246\17\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\6\11\1\247\21\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\3\11\1\250"+
    "\24\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\1\251\3\11\1\252\23\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\11\11\1\253\16\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\6\11\1\254\21\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\23\11"+
    "\1\255\4\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\15\11\1\256\12\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\1\257\12\11\1\260\2\11\1\261"+
    "\11\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\4\11\1\262\10\11\1\263\12\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\3\11\1\264\24\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\2\11\1\265"+
    "\1\266\24\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\11\11\1\267\16\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\1\270\27\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\1\271\27\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\11\11\1\272\16\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\2\11"+
    "\1\273\25\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\3\11\1\274\24\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\3\11\1\275\24\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\26\11\1\276\1\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\7\11"+
    "\1\277\20\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\2\11\1\300\1\301\24\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\23\11\1\302\4\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\16\11\1\303"+
    "\11\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\21\11\1\304\6\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\7\11\1\305\20\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\4\11\1\306\23\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\6\11\1\307"+
    "\21\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\11\11\1\310\16\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\5\11\1\311\22\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\6\11\1\312\6\11\1\313"+
    "\12\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\1\11\1\314\26\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\3\11\1\315\24\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\7\11\1\316\5\11\1\317"+
    "\12\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\15\11\1\320\12\11\24\0\2\11\67\0\1\321\1\322"+
    "\103\0\1\323\25\0\1\210\4\0\3\210\75\0\1\324"+
    "\4\0\3\324\75\0\1\325\4\0\3\325\5\0\1\326"+
    "\67\0\1\327\4\0\3\327\5\0\1\326\104\0\1\330"+
    "\104\0\1\331\104\0\1\332\104\0\1\333\104\0\1\334"+
    "\104\0\1\335\104\0\1\336\104\0\1\337\57\0\5\234"+
    "\1\340\77\234\10\0\1\236\1\237\1\341\1\0\5\237"+
    "\1\0\1\237\4\0\2\237\3\0\1\237\1\0\1\341"+
    "\1\237\6\0\1\237\1\0\1\237\32\0\2\237\10\0"+
    "\2\342\1\341\1\0\5\342\1\0\1\342\4\0\2\342"+
    "\3\0\1\342\1\0\1\341\1\342\6\0\1\342\1\0"+
    "\1\342\32\0\2\342\10\0\1\343\1\103\1\235\2\0"+
    "\3\343\1\111\1\112\1\113\13\0\1\235\1\113\6\0"+
    "\1\114\1\0\1\111\33\0\1\114\10\0\1\344\1\103"+
    "\1\235\2\0\3\344\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\2\242\3\0\3\242\1\111\25\0\1\114\1\0\1\111"+
    "\33\0\1\114\10\0\2\242\3\0\3\242\73\0\13\11"+
    "\1\0\1\11\4\0\3\11\1\345\24\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\10\11\1\346\17\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\1\347"+
    "\27\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\7\11\1\350\20\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\10\11\1\351\17\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\3\11\1\352\24\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\15\11\1\353"+
    "\12\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\5\11\1\354\22\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\4\11\1\355\23\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\10\11\1\356\17\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\3\11\1\357"+
    "\24\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\11\11\1\360\16\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\10\11\1\361\17\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\6\11\1\362\21\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\2\11\1\363"+
    "\25\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\16\11\1\364\11\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\10\11\1\365\17\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\5\11\1\366\22\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\2\11\1\367"+
    "\1\370\24\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\2\11\1\371\25\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\4\11\1\372\23\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\24\11\1\373\3\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\10\11"+
    "\1\374\17\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\10\11\1\375\17\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\15\11\1\376\12\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\7\11\1\377\20\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\3\11"+
    "\1\u0100\24\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\10\11\1\u0101\17\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\6\11\1\u0102\1\u0103\20\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\1\11\1\u0104"+
    "\26\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\1\u0105\27\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\2\11\1\u0106\25\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\1\u0107\27\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\1\u0108\27\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\12\11\1\u0109\15\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\3\11"+
    "\1\u010a\24\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\25\11\1\u010b\2\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\7\11\1\u010c\20\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\6\11\1\u010d\21\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\1\u010e"+
    "\27\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\17\11\1\u010f\10\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\7\11\1\u0110\20\11\24\0\2\11\67\0"+
    "\1\u0111\42\0\1\326\57\0\4\234\1\6\1\340\77\234"+
    "\10\0\2\u0112\1\341\1\0\5\u0112\1\0\1\u0112\4\0"+
    "\2\u0112\3\0\1\u0112\1\0\1\341\1\u0112\6\0\1\u0112"+
    "\1\0\1\u0112\32\0\2\u0112\10\0\1\u0113\1\103\1\235"+
    "\2\0\3\u0113\1\111\1\112\1\113\13\0\1\235\1\113"+
    "\6\0\1\114\1\0\1\111\33\0\1\114\10\0\1\u0114"+
    "\1\103\1\235\2\0\3\u0114\1\111\1\112\1\113\13\0"+
    "\1\235\1\113\6\0\1\114\1\0\1\111\33\0\1\114"+
    "\6\0\13\11\1\0\1\11\4\0\4\11\1\u0115\23\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\4\11"+
    "\1\u0116\23\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\12\11\1\u0117\15\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\10\11\1\u0118\17\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\15\11\1\u0119\12\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\5\11"+
    "\1\u011a\22\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\14\11\1\u011b\13\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\3\11\1\u011c\24\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\4\11\1\u011d\23\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\5\11"+
    "\1\u011e\22\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\2\11\1\u011f\25\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\26\11\1\u0120\1\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\4\11\1\u0121\23\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\14\11"+
    "\1\u0122\13\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\3\11\1\u0123\24\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\15\11\1\u0124\12\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\2\11\1\u0125\25\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\11\11"+
    "\1\u0126\16\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\25\11\1\u0127\2\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\1\u0128\27\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\4\11\1\u0129\23\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\4\11\1\u012a"+
    "\23\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\10\11\1\u012b\17\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\7\11\1\u012c\20\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\16\11\1\u012d\11\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\10\11\1\u012e"+
    "\17\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\3\11\1\u012f\24\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\7\11\1\u0130\20\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\1\u0131\27\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\10\11\1\u0132\17\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\1\u0133"+
    "\27\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\15\11\1\u0134\12\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\3\11\1\u0135\24\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\10\11\1\u0136\17\11\24\0"+
    "\2\11\10\0\2\u0137\1\341\1\0\5\u0137\1\0\1\u0137"+
    "\4\0\2\u0137\3\0\1\u0137\1\0\1\341\1\u0137\6\0"+
    "\1\u0137\1\0\1\u0137\32\0\2\u0137\10\0\1\u0138\1\103"+
    "\1\235\2\0\3\u0138\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u0139\1\103\1\235\2\0\3\u0139\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\6\0\13\11\1\0\1\11\4\0\1\u013a\27\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\3\11"+
    "\1\u013b\24\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\1\u013c\27\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\5\11\1\u013d\22\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\3\11\1\u013e\24\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\4\11\1\u013f"+
    "\23\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\14\11\1\u0140\13\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\15\11\1\u0141\12\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\2\11\1\u0142\25\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\11\11\1\u0143"+
    "\16\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\11\11\1\u0144\16\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\17\11\1\u0145\10\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\10\11\1\u0146\17\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\11\11\1\u0147"+
    "\16\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\21\11\1\u0148\6\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\3\11\1\u0149\24\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\22\11\1\u014a\5\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\10\11\1\u014b"+
    "\17\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\7\11\1\u014c\20\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\7\11\1\u014d\20\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\24\11\1\u014e\3\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\5\11\1\u014f"+
    "\22\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\3\11\1\u0150\24\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\5\11\1\u0151\22\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\15\11\1\u0152\12\11\24\0"+
    "\2\11\10\0\2\u0153\1\341\1\0\5\u0153\1\0\1\u0153"+
    "\4\0\2\u0153\3\0\1\u0153\1\0\1\341\1\u0153\6\0"+
    "\1\u0153\1\0\1\u0153\32\0\2\u0153\10\0\1\u0154\1\103"+
    "\1\235\2\0\3\u0154\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u0155\1\103\1\235\2\0\3\u0155\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\6\0\13\11\1\0\1\11\4\0\5\11\1\u0156"+
    "\22\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\11\11\1\u0157\16\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\21\11\1\u0158\6\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\6\11\1\u0159\21\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\10\11\1\u015a"+
    "\17\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\16\11\1\u015b\11\11\24\0\2\11\6\0\13\11\1\0"+
    "\1\11\4\0\2\11\1\u015c\25\11\24\0\2\11\6\0"+
    "\13\11\1\0\1\11\4\0\5\11\1\u015d\22\11\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\1\u015e\27\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\10\11"+
    "\1\u015f\17\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\3\11\1\u0160\24\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\13\11\1\u0161\14\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\10\11\1\u0162\17\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\3\11"+
    "\1\u0163\24\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\10\11\1\u0164\17\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\7\11\1\u0165\20\11\24\0\2\11"+
    "\10\0\2\u0166\1\341\1\0\5\u0166\1\0\1\u0166\4\0"+
    "\2\u0166\3\0\1\u0166\1\0\1\341\1\u0166\6\0\1\u0166"+
    "\1\0\1\u0166\32\0\2\u0166\10\0\1\u0167\1\103\1\235"+
    "\2\0\3\u0167\1\111\1\112\1\113\13\0\1\235\1\113"+
    "\6\0\1\114\1\0\1\111\33\0\1\114\10\0\1\u0168"+
    "\1\103\1\235\2\0\3\u0168\1\111\1\112\1\113\13\0"+
    "\1\235\1\113\6\0\1\114\1\0\1\111\33\0\1\114"+
    "\6\0\13\11\1\0\1\11\4\0\3\11\1\u0169\24\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\23\11"+
    "\1\u016a\4\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\11\11\1\u016b\16\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\11\11\1\u016c\16\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\10\11\1\u016d\17\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\10\11"+
    "\1\u016e\17\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\5\11\1\u016f\22\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\11\11\1\u0170\16\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\10\11\1\u0171\17\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\10\11"+
    "\1\u0172\17\11\24\0\2\11\10\0\2\u0173\1\341\1\0"+
    "\5\u0173\1\0\1\u0173\4\0\2\u0173\3\0\1\u0173\1\0"+
    "\1\341\1\u0173\6\0\1\u0173\1\0\1\u0173\32\0\2\u0173"+
    "\10\0\1\u0174\1\103\1\235\2\0\3\u0174\1\111\1\112"+
    "\1\113\13\0\1\235\1\113\6\0\1\114\1\0\1\111"+
    "\33\0\1\114\10\0\1\u0175\1\103\1\235\2\0\3\u0175"+
    "\1\111\1\112\1\113\13\0\1\235\1\113\6\0\1\114"+
    "\1\0\1\111\33\0\1\114\6\0\13\11\1\0\1\11"+
    "\4\0\15\11\1\u0176\12\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\3\11\1\u0177\24\11\24\0\2\11"+
    "\6\0\13\11\1\0\1\11\4\0\6\11\1\u0178\21\11"+
    "\24\0\2\11\6\0\13\11\1\0\1\11\4\0\10\11"+
    "\1\u0179\17\11\24\0\2\11\6\0\13\11\1\0\1\11"+
    "\4\0\3\11\1\u017a\24\11\24\0\2\11\6\0\13\11"+
    "\1\0\1\11\4\0\17\11\1\u017b\10\11\24\0\2\11"+
    "\10\0\2\u017c\1\341\1\0\5\u017c\1\0\1\u017c\4\0"+
    "\2\u017c\3\0\1\u017c\1\0\1\341\1\u017c\6\0\1\u017c"+
    "\1\0\1\u017c\32\0\2\u017c\10\0\1\u017d\1\103\1\235"+
    "\2\0\3\u017d\1\111\1\112\1\113\13\0\1\235\1\113"+
    "\6\0\1\114\1\0\1\111\33\0\1\114\10\0\1\u017e"+
    "\1\103\1\235\2\0\3\u017e\1\111\1\112\1\113\13\0"+
    "\1\235\1\113\6\0\1\114\1\0\1\111\33\0\1\114"+
    "\6\0\13\11\1\0\1\11\4\0\27\11\1\u017f\24\0"+
    "\2\11\6\0\13\11\1\0\1\11\4\0\21\11\1\u0180"+
    "\6\11\24\0\2\11\6\0\13\11\1\0\1\11\4\0"+
    "\2\11\1\u0181\25\11\24\0\2\11\10\0\2\u0182\1\341"+
    "\1\0\5\u0182\1\0\1\u0182\4\0\2\u0182\3\0\1\u0182"+
    "\1\0\1\341\1\u0182\6\0\1\u0182\1\0\1\u0182\32\0"+
    "\2\u0182\10\0\1\u0183\1\103\1\235\2\0\3\u0183\1\111"+
    "\1\112\1\113\13\0\1\235\1\113\6\0\1\114\1\0"+
    "\1\111\33\0\1\114\10\0\1\u0184\1\103\1\235\2\0"+
    "\3\u0184\1\111\1\112\1\113\13\0\1\235\1\113\6\0"+
    "\1\114\1\0\1\111\33\0\1\114\6\0\13\11\1\0"+
    "\1\11\4\0\10\11\1\u0185\17\11\24\0\2\11\10\0"+
    "\2\u0186\1\341\1\0\5\u0186\1\0\1\u0186\4\0\2\u0186"+
    "\3\0\1\u0186\1\0\1\341\1\u0186\6\0\1\u0186\1\0"+
    "\1\u0186\32\0\2\u0186\10\0\1\u0187\1\103\1\235\2\0"+
    "\3\u0187\1\111\1\112\1\113\13\0\1\235\1\113\6\0"+
    "\1\114\1\0\1\111\33\0\1\114\10\0\1\u0188\1\103"+
    "\1\235\2\0\3\u0188\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\6\0"+
    "\13\11\1\0\1\11\4\0\17\11\1\u0189\10\11\24\0"+
    "\2\11\10\0\2\u018a\1\341\1\0\5\u018a\1\0\1\u018a"+
    "\4\0\2\u018a\3\0\1\u018a\1\0\1\341\1\u018a\6\0"+
    "\1\u018a\1\0\1\u018a\32\0\2\u018a\10\0\1\u018b\1\103"+
    "\1\235\2\0\3\u018b\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u018c\1\103\1\235\2\0\3\u018c\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\2\u018d\1\341\1\0\5\u018d\1\0\1\u018d"+
    "\4\0\2\u018d\3\0\1\u018d\1\0\1\341\1\u018d\6\0"+
    "\1\u018d\1\0\1\u018d\32\0\2\u018d\10\0\1\u018e\1\103"+
    "\1\235\2\0\3\u018e\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u018f\1\103\1\235\2\0\3\u018f\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\2\u0190\1\341\1\0\5\u0190\1\0\1\u0190"+
    "\4\0\2\u0190\3\0\1\u0190\1\0\1\341\1\u0190\6\0"+
    "\1\u0190\1\0\1\u0190\32\0\2\u0190\10\0\1\u0191\1\103"+
    "\1\235\2\0\3\u0191\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u0192\1\103\1\235\2\0\3\u0192\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\2\u0193\1\341\1\0\5\u0193\1\0\1\u0193"+
    "\4\0\2\u0193\3\0\1\u0193\1\0\1\341\1\u0193\6\0"+
    "\1\u0193\1\0\1\u0193\32\0\2\u0193\10\0\1\u0194\1\103"+
    "\1\235\2\0\3\u0194\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u0195\1\103\1\235\2\0\3\u0195\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\2\u0196\1\341\1\0\5\u0196\1\0\1\u0196"+
    "\4\0\2\u0196\3\0\1\u0196\1\0\1\341\1\u0196\6\0"+
    "\1\u0196\1\0\1\u0196\32\0\2\u0196\10\0\1\u0197\1\103"+
    "\1\235\2\0\3\u0197\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u0198\1\103\1\235\2\0\3\u0198\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\2\u0199\1\341\1\0\5\u0199\1\0\1\u0199"+
    "\4\0\2\u0199\3\0\1\u0199\1\0\1\341\1\u0199\6\0"+
    "\1\u0199\1\0\1\u0199\32\0\2\u0199\10\0\1\u019a\1\103"+
    "\1\235\2\0\3\u019a\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\12\0"+
    "\1\341\23\0\1\341\56\0\1\u019b\1\103\1\235\2\0"+
    "\3\u019b\1\111\1\112\1\113\13\0\1\235\1\113\6\0"+
    "\1\114\1\0\1\111\33\0\1\114\10\0\1\u019c\1\103"+
    "\1\235\2\0\3\u019c\1\111\1\112\1\113\13\0\1\235"+
    "\1\113\6\0\1\114\1\0\1\111\33\0\1\114\10\0"+
    "\1\u019d\1\103\1\235\2\0\3\u019d\1\111\1\112\1\113"+
    "\13\0\1\235\1\113\6\0\1\114\1\0\1\111\33\0"+
    "\1\114\10\0\1\u019e\1\103\1\235\2\0\3\u019e\1\111"+
    "\1\112\1\113\13\0\1\235\1\113\6\0\1\114\1\0"+
    "\1\111\33\0\1\114\10\0\2\103\1\235\2\0\3\103"+
    "\1\111\1\112\1\113\13\0\1\235\1\113\6\0\1\114"+
    "\1\0\1\111\33\0\1\114";

  /** 
   * The transition table of the DFA
   */
  final private static int yytrans [] = yy_unpack();


  /* error codes */
  final private static int YY_UNKNOWN_ERROR = 0;
  final private static int YY_ILLEGAL_STATE = 1;
  final private static int YY_NO_MATCH = 2;
  final private static int YY_PUSHBACK_2BIG = 3;

  /* error messages for the codes above */
  final private static String YY_ERROR_MSG[] = {
    "Unkown internal scanner error",
    "Internal error: unknown state",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * YY_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private final static byte YY_ATTRIBUTE[] = {
     0,  0,  0,  9,  1,  9,  1,  1,  1,  1,  1,  1,  1,  1,  9,  9, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     9,  9,  9,  9,  9,  9,  9,  9,  1,  1,  1,  1,  9,  9,  9,  1, 
     1,  1,  1,  1,  1,  1,  9,  9,  1,  1,  1,  9,  1,  0,  0,  9, 
     9,  1,  1,  9,  0,  1,  1,  1,  9,  1,  0,  9,  9,  9,  9,  9, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  9,  9,  9,  1,  9,  1,  9,  9,  9,  9, 
     9,  9,  9,  9,  9,  9,  1,  1,  9,  9,  9,  9,  9,  9,  9,  9, 
     9,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  9,  1,  1,  1, 
     1,  1,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     9,  1,  9,  9,  0,  9,  0,  9,  9,  9,  9,  9,  9,  9,  9,  0, 
     9,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     9,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 
     1,  0,  1,  1,  1,  0,  1,  1,  1,  0,  1,  1,  0,  1,  1,  0, 
     1,  1,  0,  1,  1,  0,  1,  1,  0,  1,  1,  1,  1,  1
  };

  /** the input device */
  private java.io.Reader yy_reader;

  /** the current state of the DFA */
  private int yy_state;

  /** the current lexical state */
  private int yy_lexical_state = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private char yy_buffer[] = new char[YY_BUFFERSIZE];

  /** the textposition at the last accepting state */
  private int yy_markedPos;

  /** the textposition at the last state to be included in yytext */
  private int yy_pushbackPos;

  /** the current text position in the buffer */
  private int yy_currentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int yy_startRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int yy_endRead;

  /** number of newlines encountered up to the start of the matched text */
  private int yyline;

  /** the number of characters up to the start of the matched text */
  private int yychar;

  /**
   * the number of characters from the last newline up to the start of the 
   * matched text
   */
  private int yycolumn; 

  /** 
   * yy_atBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean yy_atBOL = true;

  /** yy_atEOF == true <=> the scanner is at the EOF */
  private boolean yy_atEOF;

  /* user code: */
    StringBuffer sb = new StringBuffer();
    String file;
    ErrorQueue eq;

    public Lexer_c(java.io.InputStream in, String file, ErrorQueue eq) {
        this(new java.io.BufferedReader(new java.io.InputStreamReader(in)),
             file, eq);
    }
    
    public Lexer_c(java.io.Reader reader, String file, ErrorQueue eq) {
        this(new EscapedUnicodeReader(reader));
        this.file = file;
        this.eq = eq;
    }

    public String file() {
        return file;
    }

    private Position pos() {
        return new Position(file, yyline+1, yycolumn, yyline+1, yycolumn+yytext().length());
    }
    private Position pos(int len) {
        return new Position(file, yyline+1, yycolumn-len-1, yyline+1, yycolumn+1);
    }
    
    private Token key(int symbol) {
        return new Keyword(pos(), yytext(), symbol);
    }

    private Token op(int symbol) {
        return new Operator(pos(), yytext(), symbol);
    }

    private Token id() {
        return new Identifier(pos(), yytext(), sym.IDENTIFIER);
    }

    private Token int_token(String s, int radix) {
        long x = parseLong(s, radix);
        return new IntegerLiteral(pos(), (int) x, sym.INTEGER_LITERAL);
    }

    private Token long_token(String s, int radix) {
        long x = parseLong(s, radix);
        return new LongLiteral(pos(), x, sym.LONG_LITERAL);
    }

    private Token float_token(String s) {
        float x = Float.valueOf(s).floatValue();
        return new FloatLiteral(pos(), x, sym.FLOAT_LITERAL);
    }

    private Token double_token(String s) {
        double x = Double.valueOf(s).doubleValue();
        return new DoubleLiteral(pos(), x, sym.DOUBLE_LITERAL);
    }
    
    private Token char_token(char x) {
        return new CharacterLiteral(pos(), x, sym.CHARACTER_LITERAL);
    }

    private Token boolean_token(boolean x) {
        return new BooleanLiteral(pos(), x, sym.BOOLEAN_LITERAL);
    }

    private Token null_token() {
        return new NullLiteral(pos(), sym.NULL_LITERAL);
    }

    private Token string_token() {
        return new StringLiteral(pos(sb.length()), sb.toString(), sym.STRING_LITERAL);
    }

  /* assumes correct representation of a long value for 
     specified radix in String s */
  private long parseLong(String s, int radix) {
    int max = s.length();
    long result = 0;
    long digit;

    for (int i = 0; i < max; i++) {
      digit = Character.digit(s.charAt(i), radix);
      result *= radix;
      result += digit;
    }

    return result;
  }


  /**
   * Creates a new scanner
   * There is also a java.io.InputStream version of this constructor.
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public Lexer_c(java.io.Reader in) {
    this.yy_reader = in;
  }

  /**
   * Creates a new scanner.
   * There is also java.io.Reader version of this constructor.
   *
   * @param   in  the java.io.Inputstream to read input from.
   */
  public Lexer_c(java.io.InputStream in) {
    this(new java.io.InputStreamReader(in));
  }

  /** 
   * Unpacks the split, compressed DFA transition table.
   *
   * @return the unpacked transition table
   */
  private static int [] yy_unpack() {
    int [] trans = new int[20700];
    int offset = 0;
    offset = yy_unpack(yy_packed0, offset, trans);
    return trans;
  }

  /** 
   * Unpacks the compressed DFA transition table.
   *
   * @param packed   the packed transition table
   * @return         the index of the last entry
   */
  private static int yy_unpack(String packed, int offset, int [] trans) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do trans[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** 
   * Unpacks the compressed character translation table.
   *
   * @param packed   the packed character translation table
   * @return         the unpacked character translation table
   */
  private static char [] yy_unpack_cmap(String packed) {
    char [] map = new char[0x10000];
    int i = 0;  /* index in packed string  */
    int j = 0;  /* index in unpacked array */
    while (i < 1664) {
      int  count = packed.charAt(i++);
      char value = packed.charAt(i++);
      do map[j++] = value; while (--count > 0);
    }
    return map;
  }


  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   * 
   * @exception   IOException  if any I/O-Error occurs
   */
  private boolean yy_refill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (yy_startRead > 0) {
      System.arraycopy(yy_buffer, yy_startRead, 
                       yy_buffer, 0, 
                       yy_endRead-yy_startRead);

      /* translate stored positions */
      yy_endRead-= yy_startRead;
      yy_currentPos-= yy_startRead;
      yy_markedPos-= yy_startRead;
      yy_pushbackPos-= yy_startRead;
      yy_startRead = 0;
    }

    /* is the buffer big enough? */
    if (yy_currentPos >= yy_buffer.length) {
      /* if not: blow it up */
      char newBuffer[] = new char[yy_currentPos*2];
      System.arraycopy(yy_buffer, 0, newBuffer, 0, yy_buffer.length);
      yy_buffer = newBuffer;
    }

    /* finally: fill the buffer with new input */
    int numRead = yy_reader.read(yy_buffer, yy_endRead, 
                                            yy_buffer.length-yy_endRead);

    if (numRead < 0) {
      return true;
    }
    else {
      yy_endRead+= numRead;  
      return false;
    }
  }


  /**
   * Closes the input stream.
   */
  final public void yyclose() throws java.io.IOException {
    yy_atEOF = true;            /* indicate end of file */
    yy_endRead = yy_startRead;  /* invalidate buffer    */

    if (yy_reader != null)
      yy_reader.close();
  }


  /**
   * Closes the current stream, and resets the
   * scanner to read from a new input stream.
   *
   * All internal variables are reset, the old input stream 
   * <b>cannot</b> be reused (internal buffer is discarded and lost).
   * Lexical state is set to <tt>YY_INITIAL</tt>.
   *
   * @param reader   the new input stream 
   */
  final public void yyreset(java.io.Reader reader) throws java.io.IOException {
    yyclose();
    yy_reader = reader;
    yy_atBOL  = true;
    yy_atEOF  = false;
    yy_endRead = yy_startRead = 0;
    yy_currentPos = yy_markedPos = yy_pushbackPos = 0;
    yyline = yychar = yycolumn = 0;
    yy_lexical_state = YYINITIAL;
  }


  /**
   * Returns the current lexical state.
   */
  final public int yystate() {
    return yy_lexical_state;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  final public void yybegin(int newState) {
    yy_lexical_state = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  final public String yytext() {
    return new String( yy_buffer, yy_startRead, yy_markedPos-yy_startRead );
  }


  /**
   * Returns the character at position <tt>pos</tt> from the 
   * matched text. 
   * 
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch. 
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  final public char yycharat(int pos) {
    return yy_buffer[yy_startRead+pos];
  }


  /**
   * Returns the length of the matched text region.
   */
  final public int yylength() {
    return yy_markedPos-yy_startRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of 
   * yypushback(int) and a match-all fallback rule) this method 
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void yy_ScanError(int errorCode) {
    String message;
    try {
      message = YY_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = YY_ERROR_MSG[YY_UNKNOWN_ERROR];
    }

    throw new Error(message);
  } 


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  private void yypushback(int number)  {
    if ( number > yylength() )
      yy_ScanError(YY_PUSHBACK_2BIG);

    yy_markedPos -= number;
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   IOException  if any I/O-Error occurs
   */
  public Token nextToken() throws java.io.IOException {
    int yy_input;
    int yy_action;

    // cached fields:
    int yy_currentPos_l;
    int yy_startRead_l;
    int yy_markedPos_l;
    int yy_endRead_l = yy_endRead;
    char [] yy_buffer_l = yy_buffer;
    char [] yycmap_l = yycmap;

    int [] yytrans_l = yytrans;
    int [] yy_rowMap_l = yy_rowMap;
    byte [] yy_attr_l = YY_ATTRIBUTE;

    while (true) {
      yy_markedPos_l = yy_markedPos;

      boolean yy_r = false;
      for (yy_currentPos_l = yy_startRead; yy_currentPos_l < yy_markedPos_l;
                                                             yy_currentPos_l++) {
        switch (yy_buffer_l[yy_currentPos_l]) {
        case '\u000B':
        case '\u000C':
        case '\u0085':
        case '\u2028':
        case '\u2029':
          yyline++;
          yycolumn = 0;
          yy_r = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          yy_r = true;
          break;
        case '\n':
          if (yy_r)
            yy_r = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          yy_r = false;
          yycolumn++;
        }
      }

      if (yy_r) {
        // peek one character ahead if it is \n (if we have counted one line too much)
        boolean yy_peek;
        if (yy_markedPos_l < yy_endRead_l)
          yy_peek = yy_buffer_l[yy_markedPos_l] == '\n';
        else if (yy_atEOF)
          yy_peek = false;
        else {
          boolean eof = yy_refill();
          yy_markedPos_l = yy_markedPos;
          yy_buffer_l = yy_buffer;
          if (eof) 
            yy_peek = false;
          else 
            yy_peek = yy_buffer_l[yy_markedPos_l] == '\n';
        }
        if (yy_peek) yyline--;
      }
      yy_action = -1;

      yy_startRead_l = yy_currentPos_l = yy_currentPos = 
                       yy_startRead = yy_markedPos_l;

      yy_state = yy_lexical_state;


      yy_forAction: {
        while (true) {

          if (yy_currentPos_l < yy_endRead_l)
            yy_input = yy_buffer_l[yy_currentPos_l++];
          else if (yy_atEOF) {
            yy_input = YYEOF;
            break yy_forAction;
          }
          else {
            // store back cached positions
            yy_currentPos  = yy_currentPos_l;
            yy_markedPos   = yy_markedPos_l;
            boolean eof = yy_refill();
            // get translated positions and possibly new buffer
            yy_currentPos_l  = yy_currentPos;
            yy_markedPos_l   = yy_markedPos;
            yy_buffer_l      = yy_buffer;
            yy_endRead_l     = yy_endRead;
            if (eof) {
              yy_input = YYEOF;
              break yy_forAction;
            }
            else {
              yy_input = yy_buffer_l[yy_currentPos_l++];
            }
          }
          int yy_next = yytrans_l[ yy_rowMap_l[yy_state] + yycmap_l[yy_input] ];
          if (yy_next == -1) break yy_forAction;
          yy_state = yy_next;

          int yy_attributes = yy_attr_l[yy_state];
          if ( (yy_attributes & 1) == 1 ) {
            yy_action = yy_state; 
            yy_markedPos_l = yy_currentPos_l; 
            if ( (yy_attributes & 8) == 8 ) break yy_forAction;
          }

        }
      }

      // store back cached position
      yy_markedPos = yy_markedPos_l;

      switch (yy_action) {

        case 369: 
          {  return key(sym.VOLATILE);  }
        case 415: break;
        case 364: 
          {  return key(sym.CONTINUE);  }
        case 416: break;
        case 361: 
          {  return key(sym.STRICTFP);  }
        case 417: break;
        case 360: 
          {  return key(sym.ABSTRACT);  }
        case 418: break;
        case 355: 
          {  return key(sym.PRIVATE);  }
        case 419: break;
        case 353: 
          {  return key(sym.PACKAGE);  }
        case 420: break;
        case 352: 
          {  return key(sym.FINALLY);  }
        case 421: break;
        case 351: 
          {  return key(sym.DEFAULT);  }
        case 422: break;
        case 347: 
          {  return key(sym.EXTENDS);  }
        case 423: break;
        case 342: 
          {  return key(sym.BOOLEAN);  }
        case 424: break;
        case 209: 
          {  return op(sym.URSHIFT);  }
        case 425: break;
        case 52: 
          {  sb.append( yytext() );  }
        case 426: break;
        case 32: 
          {  return op(sym.LPAREN);  }
        case 427: break;
        case 33: 
          {  return op(sym.RPAREN);  }
        case 428: break;
        case 34: 
          {  return op(sym.LBRACE);  }
        case 429: break;
        case 35: 
          {  return op(sym.RBRACE);  }
        case 430: break;
        case 36: 
          {  return op(sym.LBRACK);  }
        case 431: break;
        case 37: 
          {  return op(sym.RBRACK);  }
        case 432: break;
        case 64: 
          {  return op(sym.MULTEQ);  }
        case 433: break;
        case 77: 
          {  return op(sym.BDDTRUE);  }
        case 434: break;
        case 79: 
          {  return op(sym.MINUSEQ);  }
        case 435: break;
        case 104: 
          {  return key(sym.IF);  }
        case 436: break;
        case 106: 
          {  return key(sym.DO);  }
        case 437: break;
        case 121: 
          {  return op(sym.RSHIFT);  }
        case 438: break;
        case 123: 
          {  return op(sym.LSHIFT);  }
        case 439: break;
        case 126: 
          {  return op(sym.ANDAND);  }
        case 440: break;
        case 129: 
          {  return op(sym.PLUSEQ);  }
        case 441: break;
        case 156: 
          {  return long_token(yytext().substring(0,yylength()-1), 8);  }
        case 442: break;
        case 217: 
          {  yybegin(YYINITIAL); return char_token('\\');  }
        case 443: break;
        case 157: 
        case 158: 
        case 225: 
        case 273: 
        case 310: 
        case 338: 
        case 357: 
        case 370: 
        case 379: 
          {  return int_token(yytext().substring(2), 16);  }
        case 444: break;
        case 336: 
          {  return key(sym.PUBLIC);  }
        case 445: break;
        case 330: 
          {  return key(sym.DOUBLE);  }
        case 446: break;
        case 328: 
          {  return key(sym.IMPORT);  }
        case 447: break;
        case 325: 
          {  return key(sym.NATIVE);  }
        case 448: break;
        case 322: 
          {  return key(sym.RETURN);  }
        case 449: break;
        case 321: 
          {  return key(sym.THROWS);  }
        case 450: break;
        case 319: 
          {  return key(sym.SWITCH);  }
        case 451: break;
        case 316: 
          {  return key(sym.STATIC);  }
        case 452: break;
        case 314: 
          {  return key(sym.ASSERT);  }
        case 453: break;
        case 309: 
          {  return key(sym.WHILE);  }
        case 454: break;
        case 303: 
          {  return key(sym.FINAL);  }
        case 455: break;
        case 302: 
          {  return key(sym.FLOAT);  }
        case 456: break;
        case 292: 
          {  return key(sym.CLASS);  }
        case 457: break;
        case 290: 
          {  return key(sym.CONST);  }
        case 458: break;
        case 289: 
          {  return key(sym.CATCH);  }
        case 459: break;
        case 287: 
          {  return key(sym.THROW);  }
        case 460: break;
        case 284: 
          {  return key(sym.SUPER);  }
        case 461: break;
        case 283: 
          {  return key(sym.SHORT);  }
        case 462: break;
        case 278: 
          {  return key(sym.BREAK);  }
        case 463: break;
        case 63: 
          {  return op(sym.DIVEQ);  }
        case 464: break;
        case 49: 
          {  return op(sym.PLUS);  }
        case 465: break;
        case 46: 
          {  return op(sym.COLON);  }
        case 466: break;
        case 44: 
          {  return op(sym.COMP);  }
        case 467: break;
        case 39: 
          {  return op(sym.COMMA);  }
        case 468: break;
        case 13: 
          {  return op(sym.MINUS);  }
        case 469: break;
        case 7: 
          {  return op(sym.MULT);  }
        case 470: break;
        case 118: 
          {  return op(sym.EQEQ);  }
        case 471: break;
        case 119: 
          {  return op(sym.ARROW);  }
        case 472: break;
        case 120: 
          {  return op(sym.GTEQ);  }
        case 473: break;
        case 122: 
          {  return op(sym.LTEQ);  }
        case 474: break;
        case 124: 
          {  return op(sym.NOTEQ);  }
        case 475: break;
        case 125: 
          {  return op(sym.ANDEQ);  }
        case 476: break;
        case 127: 
          {  return op(sym.OREQ);  }
        case 477: break;
        case 128: 
          {  return op(sym.OROR);  }
        case 478: break;
        case 131: 
          {  return op(sym.XOREQ);  }
        case 479: break;
        case 132: 
          {  return op(sym.MODEQ);  }
        case 480: break;
        case 4: 
        case 5: 
          {  /* ignore */  }
        case 481: break;
        case 66: 
        case 73: 
        case 161: 
        case 407: 
        case 409: 
        case 410: 
        case 411: 
        case 412: 
        case 413: 
          {  return double_token(yytext());  }
        case 482: break;
        case 240: 
          {  return boolean_token(true);  }
        case 483: break;
        case 9: 
        case 10: 
        case 11: 
          {  return int_token(yytext(), 10);  }
        case 484: break;
        case 65: 
        case 69: 
        case 70: 
        case 71: 
        case 159: 
        case 160: 
        case 226: 
        case 227: 
        case 274: 
        case 275: 
        case 311: 
        case 312: 
        case 339: 
        case 340: 
        case 358: 
        case 359: 
        case 371: 
        case 372: 
        case 380: 
        case 381: 
        case 386: 
        case 387: 
        case 390: 
        case 391: 
        case 394: 
        case 395: 
        case 397: 
        case 398: 
        case 400: 
        case 401: 
        case 403: 
        case 404: 
        case 406: 
          {  return int_token(yytext(), 8);  }
        case 485: break;
        case 384: 
          {  return key(sym.IMPLEMENTS);  }
        case 486: break;
        case 383: 
          {  return key(sym.INSTANCEOF);  }
        case 487: break;
        case 378: 
          {  return key(sym.PROTECTED);  }
        case 488: break;
        case 376: 
          {  return key(sym.INTERFACE);  }
        case 489: break;
        case 374: 
          {  return key(sym.TRANSIENT);  }
        case 490: break;
        case 272: 
          {  return op(sym.URSHIFTEQ);  }
        case 491: break;
        case 210: 
          {  return op(sym.LSHIFTEQ);  }
        case 492: break;
        case 208: 
          {  return op(sym.RSHIFTEQ);  }
        case 493: break;
        case 45: 
          {  return op(sym.QUESTION);  }
        case 494: break;
        case 38: 
          {  return op(sym.SEMICOLON);  }
        case 495: break;
        case 76: 
          {  return op(sym.BDDFALSE);  }
        case 496: break;
        case 130: 
          {  return op(sym.PLUSPLUS);  }
        case 497: break;
        case 254: 
          {  return null_token();  }
        case 498: break;
        case 213: 
          {  yybegin(YYINITIAL);
				    long val = parseLong(yytext().substring(1,yylength()-1), 8);
			            return char_token((char)val);  }
        case 499: break;
        case 222: 
          {  yybegin(YYINITIAL); return char_token('\f'); }
        case 500: break;
        case 221: 
          {  yybegin(YYINITIAL); return char_token('\n'); }
        case 501: break;
        case 220: 
          {  yybegin(YYINITIAL); return char_token('\r'); }
        case 502: break;
        case 219: 
          {  yybegin(YYINITIAL); return char_token('\t'); }
        case 503: break;
        case 218: 
          {  yybegin(YYINITIAL); return char_token('\b'); }
        case 504: break;
        case 216: 
          {  yybegin(YYINITIAL); return char_token('\''); }
        case 505: break;
        case 215: 
          {  yybegin(YYINITIAL); return char_token('\"'); }
        case 506: break;
        case 55: 
          {  yybegin(YYINITIAL); return string_token();  }
        case 507: break;
        case 53: 
        case 54: 
          {  eq.enqueue(ErrorInfo.LEXICAL_ERROR,
					      "Unterminated string at end of line",
					      pos());  }
        case 508: break;
        case 224: 
          {  return long_token(yytext().substring(2,yylength()-1), 16);  }
        case 509: break;
        case 67: 
          {  return long_token(yytext().substring(0,yylength()-1), 10);  }
        case 510: break;
        case 144: 
          {  yybegin(YYINITIAL); return char_token(yytext().charAt(0));  }
        case 511: break;
        case 301: 
          {  return boolean_token(false);  }
        case 512: break;
        case 15: 
          {  yybegin(CHARLITERAL);  }
        case 513: break;
        case 392: 
          {  return key(sym.SYNCHRONIZED);  }
        case 514: break;
        case 72: 
          {  return float_token(yytext().substring(0,yylength()-1));  }
        case 515: break;
        case 75: 
          {  return double_token(yytext().substring(0,yylength()-1));  }
        case 516: break;
        case 78: 
          {  return op(sym.MINUSMINUS);  }
        case 517: break;
        case 270: 
          {  return key(sym.VOID);  }
        case 518: break;
        case 268: 
          {  return key(sym.GOTO);  }
        case 519: break;
        case 251: 
          {  return key(sym.ELSE);  }
        case 520: break;
        case 250: 
          {  return key(sym.LONG);  }
        case 521: break;
        case 249: 
          {  return key(sym.CHAR);  }
        case 522: break;
        case 244: 
          {  return key(sym.CASE);  }
        case 523: break;
        case 242: 
          {  return key(sym.THIS);  }
        case 524: break;
        case 232: 
          {  return key(sym.BYTE);  }
        case 525: break;
        case 197: 
          {  return key(sym.FOR);  }
        case 526: break;
        case 192: 
          {  return key(sym.INT);  }
        case 527: break;
        case 189: 
          {  return key(sym.NEW);  }
        case 528: break;
        case 175: 
          {  return key(sym.TRY);  }
        case 529: break;
        case 143: 
          {  sb.append( '\f' );  }
        case 530: break;
        case 51: 
          {  return op(sym.MOD);  }
        case 531: break;
        case 50: 
          {  return op(sym.XOR);  }
        case 532: break;
        case 48: 
          {  return op(sym.OR);  }
        case 533: break;
        case 47: 
          {  return op(sym.AND);  }
        case 534: break;
        case 43: 
          {  return op(sym.NOT);  }
        case 535: break;
        case 42: 
          {  return op(sym.LT);  }
        case 536: break;
        case 41: 
          {  return op(sym.GT);  }
        case 537: break;
        case 40: 
          {  return op(sym.EQ);  }
        case 538: break;
        case 12: 
          {  return op(sym.DOT);  }
        case 539: break;
        case 6: 
          {  return op(sym.DIV);  }
        case 540: break;
        case 134: 
        case 135: 
        case 211: 
          {  char val = (char) Integer.parseInt(yytext().substring(1),8);
				   sb.append(val);  }
        case 541: break;
        case 136: 
          {  sb.append( '\"' );  }
        case 542: break;
        case 137: 
          {  sb.append( '\'' );  }
        case 543: break;
        case 138: 
          {  sb.append( '\\' );  }
        case 544: break;
        case 139: 
          {  sb.append( '\b' );  }
        case 545: break;
        case 140: 
          {  sb.append( '\t' );  }
        case 546: break;
        case 141: 
          {  sb.append( '\r' );  }
        case 547: break;
        case 142: 
          {  sb.append( '\n' );  }
        case 548: break;
        case 145: 
        case 146: 
        case 147: 
        case 148: 
        case 149: 
        case 150: 
        case 151: 
        case 152: 
        case 153: 
        case 154: 
          {  eq.enqueue(ErrorInfo.LEXICAL_ERROR,
                                              "Illegal escape sequence \""+yytext()+"\"",
					      pos());  }
        case 549: break;
        case 58: 
        case 59: 
          {  eq.enqueue(ErrorInfo.LEXICAL_ERROR,
                                              "Unterminated character literal at end of line",
					      pos());  }
        case 550: break;
        case 8: 
        case 16: 
        case 17: 
        case 18: 
        case 19: 
        case 20: 
        case 21: 
        case 22: 
        case 23: 
        case 24: 
        case 25: 
        case 26: 
        case 27: 
        case 28: 
        case 29: 
        case 30: 
        case 31: 
        case 80: 
        case 81: 
        case 82: 
        case 83: 
        case 84: 
        case 85: 
        case 86: 
        case 87: 
        case 88: 
        case 89: 
        case 90: 
        case 91: 
        case 92: 
        case 93: 
        case 94: 
        case 95: 
        case 96: 
        case 97: 
        case 98: 
        case 99: 
        case 100: 
        case 101: 
        case 102: 
        case 103: 
        case 105: 
        case 107: 
        case 108: 
        case 109: 
        case 110: 
        case 111: 
        case 112: 
        case 113: 
        case 114: 
        case 115: 
        case 116: 
        case 117: 
        case 163: 
        case 164: 
        case 165: 
        case 166: 
        case 167: 
        case 168: 
        case 169: 
        case 170: 
        case 171: 
        case 172: 
        case 173: 
        case 174: 
        case 176: 
        case 177: 
        case 178: 
        case 179: 
        case 180: 
        case 181: 
        case 182: 
        case 183: 
        case 184: 
        case 185: 
        case 186: 
        case 187: 
        case 188: 
        case 190: 
        case 191: 
        case 193: 
        case 194: 
        case 195: 
        case 196: 
        case 198: 
        case 199: 
        case 200: 
        case 201: 
        case 202: 
        case 203: 
        case 204: 
        case 205: 
        case 206: 
        case 207: 
        case 228: 
        case 229: 
        case 230: 
        case 231: 
        case 233: 
        case 234: 
        case 235: 
        case 236: 
        case 237: 
        case 238: 
        case 239: 
        case 241: 
        case 243: 
        case 245: 
        case 246: 
        case 247: 
        case 248: 
        case 252: 
        case 253: 
        case 255: 
        case 256: 
        case 257: 
        case 258: 
        case 259: 
        case 260: 
        case 261: 
        case 262: 
        case 263: 
        case 264: 
        case 265: 
        case 266: 
        case 267: 
        case 269: 
        case 271: 
        case 276: 
        case 277: 
        case 279: 
        case 280: 
        case 281: 
        case 282: 
        case 285: 
        case 286: 
        case 288: 
        case 291: 
        case 293: 
        case 294: 
        case 295: 
        case 296: 
        case 297: 
        case 298: 
        case 299: 
        case 300: 
        case 304: 
        case 305: 
        case 306: 
        case 307: 
        case 308: 
        case 313: 
        case 315: 
        case 317: 
        case 318: 
        case 320: 
        case 323: 
        case 324: 
        case 326: 
        case 327: 
        case 329: 
        case 331: 
        case 332: 
        case 333: 
        case 334: 
        case 335: 
        case 337: 
        case 341: 
        case 343: 
        case 344: 
        case 345: 
        case 346: 
        case 348: 
        case 349: 
        case 350: 
        case 354: 
        case 356: 
        case 362: 
        case 363: 
        case 365: 
        case 366: 
        case 367: 
        case 368: 
        case 373: 
        case 375: 
        case 377: 
        case 382: 
        case 388: 
          {  return id();  }
        case 551: break;
        case 3: 
        case 56: 
        case 57: 
        case 60: 
          {  eq.enqueue(ErrorInfo.LEXICAL_ERROR,
                                              "Illegal character \""+yytext()+"\"",
					      pos());  }
        case 552: break;
        case 14: 
          {  yybegin(STRING); sb.setLength(0);  }
        case 553: break;
        case 133: 
          {  eq.enqueue(ErrorInfo.LEXICAL_ERROR,
                                              "Illegal escape sequence \""+yytext()+"\"",
					      pos());  }
        case 554: break;
        default: 
          if (yy_input == YYEOF && yy_startRead == yy_currentPos) {
            yy_atEOF = true;
              {         return new EOF(pos(), sym.EOF); 
 }
          } 
          else {
            yy_ScanError(YY_NO_MATCH);
          }
      }
    }
  }


}
